function readInputValue(inputID)
{
        return document.getElementById(inputID).value;
}

function readSelectValue(selectID) 
{
        return document.getElementById(selectID).options[document.getElementById(selectID).selectedIndex].value;
}

function read_radiobutton_value(name)
{
        var i = 0;
        while(currentRadio = document.getElementById(name + "_" + i)) {
                if (currentRadio.checked)
                        return i;
                i++;
        }
        return -1;
}


var infoboxRow = -1;
var numberOfJourneysShown = 4;

function toggleRowHighlight(row)
{
        var bordercolorMain = 'rgb(219,219,219)';
        //var bordercolorHighlight = '#333333';
        if (DEFAULTCUSTOMER == '6')  // Skånetrafiken 
                var bordercolorHighlight = 'rgb(146,28,32)';
         else // Övriga
                var bordercolorHighlight = 'black';
        
        var backgroundcolorMain = 'transparent';
        //var backgroundcolorHighlight = '#f1ebeb';
        var backgroundcolorHighlight = '#eeeeee';
        
        if (row == infoboxRow) {
                var bordercolorNew = bordercolorMain;  
                var backgroundcolorNew = backgroundcolorMain;
        } else {
                var bordercolorNew = bordercolorHighlight;  
                var backgroundcolorNew = backgroundcolorHighlight;
        }       
        
        // Fixa border på raden över
        if (document.getElementById('timetableRow_' + (row - 1)) != null) {
                document.getElementById('timetableRow_' + (row-1)).style.borderBottomStyle = 'none';
                document.getElementById('timetableRow_' + (row-1)).style.borderLeftStyle = 'none';
                document.getElementById('timetableRow_' + (row-1)).style.borderRightStyle = 'none';
        }
        
        // Fixa border på raden under
        if (document.getElementById('timetableRow_' + (row + 1)) != null) {
                document.getElementById('timetableRow_' + (row+1)).style.borderTopStyle = 'none';
                document.getElementById('timetableRow_' + (row+1)).style.borderLeftStyle = 'none';
                document.getElementById('timetableRow_' + (row+1)).style.borderRightStyle = 'none';
        }
        
        if (document.getElementById('timetableRow_' + row)) {
                document.getElementById('timetableRow_' + row).style.border = '1px solid ' + bordercolorNew;
                document.getElementById('timetableRow_' + row).style.backgroundColor = backgroundcolorNew;
        }

}

function showInfobox(row, querystring) 
{
        // If already open, close infobox
        if (row == infoboxRow) {
                toggleRowHighlight(row);
                closeInfobox();
        // Open/Change box
	} else { 
                document.getElementById('timetableRow_' + row).style.border = '1px solid #000000';
                if (infoboxRow != -1)
                        toggleRowHighlight(infoboxRow);
                
                toggleRowHighlight(row);
		 
		loadPageinDiv(WIDGETURL, 'resultspage', querystring, null, 'divInfoboxContent');
                
                infoboxRow = row;
	} 
}

function closeInfobox()
{

        // Av-highlighta om någon rad är öppen
        if (infoboxRow != -1) {
                toggleRowHighlight(infoboxRow);
                        infoboxRow = -1;
        }
                
        // Stäng infoboxen och resiza widgeten
        document.getElementById('divInfobox').style.visibility='hidden'; 
        window.resizeTo(originalWindowWidth, originalWindowHeight);
        
}



//Krävs för postar som innehåller svenska tecken eller mellanslag
function encodePostParam(string) 
{
        var newString = string;
        
        // Byt ut alla svenska tecken
        swedishChars = new Array('å', '&aring;',
                                'ä', '&auml;',
                                'ö', '&ouml;',
                                'Å', '&Aring;',
                                'Ä', '&Auml;',
                                'Ö', '&Ouml;'
                                );
                                
        for (var i = 0; i < swedishChars.length; i+=2) {
                newString = newString.replace(new RegExp(swedishChars[i], 'g'), swedishChars[i+1]);
        }
        
        // Escape:a för att klara mellanslag om det behövs, kan ej göras två ggr!
        var returnString = newString;
        
        returnString = escape(returnString);
        
        return returnString;
}

//Krävs för postar som innehåller svenska tecken eller mellanslag

function showSearchPage(cmdAction) 
{
        var currentLanguage = getCurrentLanguage(false);
        var customerArray = getCurrentCustomerDetails();

        params = 'customer=' + customerArray[1] + 
                '&language=' + currentLanguage +
                '&cmdAction=' + cmdAction;
        
        if (cmdAction == 'edit' || cmdAction == 'retour') {
                params = params + '&inpDate=' + readInputValue('inpDate') + 
                                        '&inpTime=' + readInputValue('inpTime') + 
                                        '&selDirection=' + readInputValue('selDirection');
        }
        
        switch (cmdAction) {
                case "edit":
                        params = params + 
                                '&inpPointFr=' + encodePostParam(readInputValue('inpPointFr')) + 
                                '&inpPointTo=' + encodePostParam(readInputValue('inpPointTo')) +
                                '&inpPointFrEdit=' + encodePostParam(readInputValue('inpPointFrEdit')) +
                                '&inpPointToEdit=' + encodePostParam(readInputValue('inpPointToEdit'))
                                ;
                break;
                case "retour":
                        params = params + 
                                '&inpPointFr=' + encodePostParam(readInputValue('inpPointTo')) + 
                                '&inpPointTo=' + encodePostParam(readInputValue('inpPointFr'));
                break;
        }
        
                
        loadPageinDiv(WIDGETURL, 'searchpage', '', params, 'divMainContent'); 
}

function showQueryPage(cmdAction) 
{
        var currentLanguage = getCurrentLanguage(false);
        var customerArray = getCurrentCustomerDetails();
        params = 'customer=' + customerArray[1] + 
                '&language=' + currentLanguage +
                '&inpDate=' + readInputValue('inpDate') + 
                '&inpTime=' + readInputValue('inpTime') + 
                '&cmdAction=' + cmdAction;
        
        if (cmdAction == 'search') {
                params = params + '&selDirection=' + readSelectValue('selDirection'); 
                params = params + '&inpPointFr=' + readInputValue('inpPointFr') + 
                                        '&inpPointTo=' + readInputValue('inpPointTo') + 
                                        '&inpPointFrEdit=' + encodePostParam(readInputValue('inpPointFr')) +
                                        '&inpPointToEdit=' + encodePostParam(readInputValue('inpPointTo'))
                                        ;
        }
        
        else if (cmdAction == 'retour') {
                params = params + '&selDirection=' + readInputValue('selDirection');
                
                params = params + '&inpPointFr=' + encodePostParam(readInputValue('inpPointFr')) + 
                                        '&inpPointTo=' + encodePostParam(readInputValue('inpPointTo')) + 
                                        '&selPointFr=' + encodePostParam(readInputValue('selPointFr')) + 
                                        '&selPointTo=' + encodePostParam(readInputValue('selPointTo')) + 
                                        '&selPointFrKey=' + readInputValue('selPointFrKey') +
                                        '&selPointToKey=' + readInputValue('selPointToKey') +
                                        '&optTypeFr=' + readInputValue('optTypeFr') +
                                        '&optTypeTo=' + readInputValue('optTypeTo');
        }
            
        loadPageinDiv(WIDGETURL, 'querypage', '', params, 'divMainContent'); 
}

function showBackPage() 
{
        if (widget.preferenceForKey("language") == null) {
                widget.setPreferenceForKey("en", "language");
        }

        params = null;
        loadPageinDiv(WIDGETURL, 'backpage', '', params, 'divMainContentBack'); 
}

function showResultsPageFromSettings(startupState) {
        
        selPointFr = widget.preferenceForKey(dashcode.createInstancePreferenceKey('selPointFr'));
        selPointTo = widget.preferenceForKey(dashcode.createInstancePreferenceKey('selPointTo'));
        if (startupState == 1) {
                inpDate = widget.preferenceForKey(dashcode.createInstancePreferenceKey('inpDate'));
                inpTime = widget.preferenceForKey(dashcode.createInstancePreferenceKey('inpTime'));
                cmdAction = widget.preferenceForKey(dashcode.createInstancePreferenceKey('cmdAction'));
        } else {
                inpDate = '';
                inpTime = '';
                cmdAction = 'search';
        }
        
        if (selPointFr == null || selPointTo == null) {
                showSearchPage(null);
                return;
        }
        
        selDirection = widget.preferenceForKey(dashcode.createInstancePreferenceKey('selDirection'));
        
        var currentLanguage = getCurrentLanguage(false);
        var customerArray = getCurrentCustomerDetails();
        
        params = 'customer=' + customerArray[1] + 
                '&language=' + currentLanguage +
                '&selPointFr=' + selPointFr + 
                '&selPointTo=' + selPointTo + 
                '&inpDate=' + inpDate + 
                '&inpTime=' + inpTime + 
                '&selDirection=' + selDirection + 
                '&cmdAction=' + cmdAction
                ;
                
        loadPageinDiv(WIDGETURL,'resultspage', '', params, 'divMainContent'); 
}
  

function showResultsPage(cmdAction) {

        var customerArray = getCurrentCustomerDetails();
        
        selPointFr = encodePostParam(readSelectValue('selPointFr'));
        selPointTo = encodePostParam(readSelectValue('selPointTo'));
        inpDate = readInputValue('inpDate');
        inpTime = readInputValue('inpTime');
        selDirection = readInputValue('selDirection');
        var currentLanguage = getCurrentLanguage(false);
        
        params = 'customer=' + customerArray[1] + 
                '&language=' + currentLanguage +
                '&selPointFr=' + selPointFr + 
                '&selPointTo=' + selPointTo + 
                '&inpDate=' + inpDate + 
                '&inpTime=' + inpTime + 
                '&selDirection=' + selDirection + 
                '&cmdAction=' + cmdAction
                ;
                
        saveLastSearch(selPointFr, selPointTo, inpDate, inpTime, selDirection, cmdAction);

        loadPageinDiv(WIDGETURL,'resultspage', '', params, 'divMainContent'); 
}

function showResultsPageChange(cmdAction) {

        selPointFr = encodePostParam(readInputValue('selPointFr'));
        selPointTo = encodePostParam(readInputValue('selPointTo'));
        inpDate = readInputValue('inpDate');
        inpTime = readInputValue('inpTime');
        selDirection = readInputValue('selDirection');
        var currentLanguage = getCurrentLanguage(false);
         var customerArray = getCurrentCustomerDetails();
         
        params = 'customer=' + customerArray[1] +
                '&language=' + currentLanguage +
                '&selPointFr=' + selPointFr + 
                '&selPointTo=' + selPointTo + 
                '&inpPointFr=' + readInputValue('inpPointFr') + 
                '&inpPointTo=' + readInputValue('inpPointTo') + 
                '&selPointFrKey=' + readInputValue('selPointFrKey') +
                '&selPointToKey=' + readInputValue('selPointToKey') +
                '&optTypeFr=' + readInputValue('optTypeFr') +
                '&optTypeTo=' + readInputValue('optTypeTo') +
                '&inpDate=' + inpDate + 
                '&inpTime=' + inpTime + 
                '&selDirection=' + selDirection +
                '&FirstStart=' + escape(readInputValue('FirstStart')) +
                '&LastStart=' + escape(readInputValue('LastStart')) +
                '&CacheFile=' + readInputValue('CacheFile') +
                '&cmdAction=' + cmdAction
                ;
    
        saveLastSearch(selPointFr, selPointTo, inpDate, inpTime, selDirection, 'search'); 
        
        loadPageinDiv(WIDGETURL, 'resultspage', '', params, 'divMainContent'); 
}

function saveLastSearch(selPointFr, selPointTo, inpDate, inpTime, selDirection, cmdAction)
{
        widget.setPreferenceForKey(selPointFr, dashcode.createInstancePreferenceKey('selPointFr'));
        widget.setPreferenceForKey(selPointTo, dashcode.createInstancePreferenceKey('selPointTo'));
        widget.setPreferenceForKey(inpDate, dashcode.createInstancePreferenceKey('inpDate'));
        widget.setPreferenceForKey(inpTime, dashcode.createInstancePreferenceKey('inpTime'));
        widget.setPreferenceForKey(selDirection, dashcode.createInstancePreferenceKey('selDirection'));
        widget.setPreferenceForKey(cmdAction, dashcode.createInstancePreferenceKey('cmdAction'));
}

function saveSettings() 
{
        widget.setPreferenceForKey(read_radiobutton_value('radioStartupState'), dashcode.createInstancePreferenceKey('startupState'));
        widget.setPreferenceForKey(readSelectValue('selectLanguage'), 'language');
        /*
        var newCustomer = readSelectValue('selectCustomer');
        widget.setPreferenceForKey(newCustomer, dashcode.createInstancePreferenceKey('customer'));
        widget.setPreferenceForKey(newCustomer, 'lastCustomer');
        */
}


